############################################################################## 
# 
# This program is free software; you can redistribute it and/or modify 
# it under the terms of the GNU General Public License as published by 
# the Free Software Foundation; either version 2 of the License, or 
# (at your option) any later version. 
# 
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU General Public License for more details. 
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software 
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
# 
# Jabber 
# Copyright (C) 1998-2002 The Jabber Team http://jabber.org/ 
# 
############################################################################## 
 
############################################################################## 
# 
# ChatBot Eliza PlugIn - handles putting some spunk into ChatBot by wiring 
# the Eliza program into place when you address 
# ChatBot. 
# 
############################################################################## 
 
use strict; 
use Chatbot::Eliza;  
 
 
############################################################################## 
# 
# Register Events 
# 
############################################################################## 
&RegisterEvent("groupchat_message",\&plugin_eliza_eliza); 
&RegisterEvent("chat_message",\&plugin_eliza_eliza); 
 
 
############################################################################## 
# 
# Register Flags 
# 
############################################################################## 
&RegisterFlag("eliza"); 
 
 
############################################################################## 
# 
# Instantiate an Eliza 
# 
############################################################################## 
$plugin_env{eliza}->{eliza} = new Chatbot::Eliza; 
 
 
############################################################################## 
# 
# plugin_eliza_eliza - prints out the current eliza in UTC 
# 
############################################################################## 
sub plugin_eliza_eliza 
{ 
#require "syscall.ph"; 
my $message = shift; 
 
my $fromJID = $message->GetFrom("jid"); 
 
return unless &CheckFlag($fromJID->GetJID(),"eliza"); 
my $nick = &ChatBotNick($fromJID->GetJID()); 
my $body = $message->GetBody(); 
my $fromNick = $fromJID->GetResource(); 
 
return if ($fromNick eq ""); 
return if ($fromNick =~ /$nick/); 
return unless ($body =~ /$nick/i); 
 
if ($body =~ /^\s*$nick\:(.*)$/) { 
$body = substr($body,length($nick)+2); 
}  
my $input = $1; 
my $s = "/PATH TO YOUR PROGRAM E INSTALLATION/conv.sh ".$nick." ".$fromNick." \"".urlencode($body)."\"";  
#print $s; 
my $reply = urldecode(readpipe($s)); 
 
return ($message->GetType(),$fromJID->GetResource().": $reply"); 
} 
sub urldecode { 
my($string) = $_[0]; 
print $string; 
$string =~ s/\+/ /g;  
$string =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("c",hex($1))/eg; 
#print $string; 
return($string); 
} 
sub urlencode { 
my ($string) = $_[0]; 
$string =~ s/([^A-Za-z0-9])/sprintf("%%%2X", ord($1))/eg; 
$string =~ s/%20/+/g; 
return ($string); 
} 
1; 
